



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CSS： word-wrap和word-break</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CSS： word-wrap和word-break</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 09:06:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近修改页面排版的一些问题，发现关于内容分词换行有两个主要的CSS：</p>
<p><strong>word-wrap 和 word-break</strong></p>
<p>特别是word-wrap还有个取值break-word，更使得这两个属性容易混淆。</p>
<p>先来看看这两个属性的定义和取值吧：</p>
<p>word-warp：用来表明是否允许<strong>长单词</strong>内断句而移至下一行。</p>
<table>
<tbody>
<tr>
<td>
<p>normal</p>
</td>
<td>
<p>只在允许断句点进行断句。比如单词连接符&ldquo;-&rdquo;。</p>
</td>
</tr>
<tr>
<td>
<p><strong>break-word</strong></p>
</td>
<td>
<p>内容将在边界内换行。如果需要，单词内部允许断句。</p>
</td>
</tr>
</tbody>
</table>
<p>word-break：指定行内断句规则。</p>
<table>
<tbody>
<tr>
<td>
<p>normal</p>
</td>
<td>
<p>依照不同文本的规则决定是否在单词内断句。</p>
</td>
</tr>
<tr>
<td>
<p>break-all</p>
</td>
<td>
<p>允许单词内断句。</p>
</td>
</tr>
<tr>
<td>
<p>keep-all</p>
</td>
<td>
<p>不允许在成对单词间断句，主要是针对亚洲文本，对于中文，韩文，日文，不允许字断开。</p>
</td>
</tr>
</tbody>
</table>
<p>PS. 上面两个CSS实际上对中文影响不大，主要是针对英文。</p>
<p>让我们看看默认情况下浏览器的行为，大致上都一样（代码见文末）：</p>
<p>测试浏览器版本：Firefox 24.0 , Chrome 30.0 , IE10, IE8</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/512099/201404/302144138456270.jpg" /></p>
<p>从上面可以看出，其实换行是一种默认行为，如果容器宽度不足，会在允许换行的点进行换行（比如空格，单词连接符等等）。因此，<strong>word-wrap</strong><strong>其实是专门为长单词准备的</strong>。</p>
<p>接下来，看看加上 word-wrap: break-word 之后，<strong>除了</strong><strong>IE8</strong><strong>以外</strong>，其他行为基本一致：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/512099/201404/302144177676701.jpg" /></p>
<p>而至于低版本的IE，好吧，悲剧的数字符号：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/512099/201404/302144207674218.jpg" /></p>
<p><strong>总结下word-wrap: break-word的问题：</strong></p>
<p>1. 在长单词的上一行可能会留下大量空白，但是由于一般单词长度并不会出现那么多字符，因此这个缺点其实可以接受；</p>
<p>2. 低版本的IE对于带符号的数字不作为一个整体来断句。</p>
<p>再来看看word-break:break-all的用法，首先要注意一点，它必须与word-wrap: break-word一起使用才能起作用。包括旧版本的IE，几个浏览器的行为都基本一致了：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/512099/201404/302144240336750.jpg" /></p>
<p>可以看出，<strong>break-all的行为简单粗暴，就是完全不考虑单词连贯性，直接将其断句。</strong>这样虽然看上去节省了空间，但是却损失了可读性。<strong>因此，除非页面中出现连续无意义的长字符，否则不建议用起进行单词换行处理。</strong></p>
<p>另一方面，可以看到，break-all可以解决低版本IE带符号数字的问题，因此可以考虑将其单独用在数字上。（适合不是有多个数字在同一容器）</p>
<p>HTML代码</p>
<div>
<pre class="prettyprint linenums">&lt;table&gt;

    &lt;tr&gt;

        &lt;th&gt;product&lt;/th&gt;

        &lt;th&gt;balance&lt;/th&gt;

    &lt;/tr&gt;

    &lt;tr&gt;

        &lt;td&gt;testtesttesttesttesttesttest&lt;/td&gt;

        &lt;td class="numeric"&gt;333333333333333333333333333&lt;/td&gt;

    &lt;/tr&gt;

    &lt;tr&gt;

        &lt;td&gt;test testtesttesttesttesttesttest&lt;/td&gt;

        &lt;td class="numeric"&gt;-99999999999.9999999&lt;/td&gt;

    &lt;/tr&gt;

    &lt;tr&gt;

        &lt;td&gt;testestestest-testtest&lt;/td&gt;

        &lt;td class="numeric"&gt;-999999999~999999999&lt;/td&gt;

    &lt;/tr&gt;

    &lt;tr&gt;

        &lt;td&gt;test testing test test test&lt;/td&gt;

        &lt;td class="numeric"&gt;8888 888888 8888 8888 8888&lt;/td&gt;

    &lt;/tr&gt;

    &lt;tr&gt;

        &lt;td&gt;中文中文中文中文中文中文中文testtesttesttesttesttest&lt;/td&gt;

        &lt;td class="numeric"&gt;0.000000000000000000000001&lt;/td&gt;

    &lt;/tr&gt;

&lt;/table&gt;        </pre>
</div>
<p>CSS代码：</p>
<div>
<pre class="prettyprint linenums">body {

    color: #000000;

    background-color: #ffffff;

    font-family: arial, verdana, sans-serif;

}

table {

    background-color: #efefef;

    border-style: solid;

    border-width: 1px;

    border-color: #999999;

    table-layout: fixed;

    width: 200px;

}

th {

    background-color: #cccccc;

    font-weight: bold;

    padding: 5px;

}

td {

    padding: 5px;

    width: 100px;

    word-wrap: break-word;

}

td.numeric {

    word-break:break-all;

}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o13wpq.html">前端：圆图头像制作--border-radius &colon; 100&percnt;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ee63q.html">http&colon;&sol;&sol;blog&period;csdn&period;net&sol;lipeng32768&sol;article&sol;details&sol;50845547</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gme3p49.html">JS 跨域问题浅析及解决方法优缺点对比（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02njwq.html">QQ炫舞官网选项卡效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1evwv9.html">基于redis实现的分布式锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0jn09.html">【HDOJ】3584 Cube</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmryv19.html">DIRECTORY&lowbar;SEPARATOR</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6pjm8.html">C&num;基本数据类型与C&plus;&plus;区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj04gd9.html">section 模块页面切换代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkw0x8.html">结构-行为-样式-angularJs笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljo6k09.html">Memcached函数整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd31779.html">Kafka官方文档翻译&mdash;&mdash;实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7mr39.html">使用make</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rrxlj9.html">python 闯关之路四（下）（并发编程与数据库编程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o2vwj8.html">PythonStudy&mdash;&mdash;如何使输出不换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wlwznq.html">java生成二维码（最初版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3loxq.html">webpack打包jQuery&comma;jQuery未定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd7pej9.html">访问服务器时一直在转圈，等待localhost响应</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w03egq.html">gulpjs</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5d3n9.html">textbox只允许输入数字</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e14kme9.html">&lbrack;ActionScript 3&period;0&rsqb; AS3 ConvolutionFilter卷积滤镜的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv2m1oq.html">Delphi中自画TStatusBar面板中的文字颜色背景以及图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn27krq.html">Understanding Python metaclasses</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mo5z1q.html">POJ 2154 【POLYA】【欧拉】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok16w59.html">20&period; Valid Parentheses（stack）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdv2xk8.html">&lbrack;C&num; 基础知识系列&rsqb;C&num;中易混淆的知识点</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1yw5x9.html">struts2常用的常量constant</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xg4j08.html">leetcode 349：两个数组的交集I</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w5rgvq.html">刻意练习，逃离舒适区&mdash;&mdash;怎么样成为一个高手&lbrack;罗辑思维&rsqb;No&period;183&lowbar;知识笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdewmm79.html">如何查看IIS并发连接数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
